Bug 1096955 - (CVE-2014-0233) CVE-2014-0233 OpenShift: downloadable cartridge source url file command execution as root
CVE-2014-0233 OpenShift: downloadable cartridge source url file command execu...
Status: CLOSED ERRATA
Product: Security Response
Classification: Other
Component: vulnerability (Show other bugs)
unspecified
All Linux
high Severity high
: ---
: ---
Assigned To: Red Hat Product Security
impact=important,public=20140521,repo...
: Security
Depends On: 1082972 1096591 1096956 1096957 1096958
Blocks: 1096963
  Show dependency treegraph
 
Reported: 2014-05-12 15:05 EDT by Kurt Seifried
Modified: 2014-08-15 09:12 EDT (History)
12 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-05-21 12:16:48 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)


External Trackers
Tracker ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2014:0529 normal SHIPPED_LIVE Important: rubygem-openshift-origin-node security update 2014-05-21 15:45:20 EDT
Red Hat Product Errata RHSA-2014:0530 normal SHIPPED_LIVE Important: rubygem-openshift-origin-node security update 2014-05-21 15:55:46 EDT

  None (edit)
Description Kurt Seifried 2014-05-12 15:05:26 EDT
Jeremy Choi of Red Hat reports:

Attackers, with normal user privilege, are able to do OS command injection
with *root* by leveraging a downloadable cartridge where its source-URL
scheme is 'file'.

In cartridge_repository.rb:

532             when 'file' == uri.scheme
533               entries = Dir.glob(PathUtils.join(uri.path, '*'), File::FNM_DO    TMATCH)
534               filesystem_copy(entries, target, %w(. ..))
...
609         Utils.oo_spawn("/bin/cp -ad #{entries.join(' ')} #{target}",
610                        expected_exitstatus: 0)

OpenShift Origin copies the directory structure from the user specified
cartridge when an application is created via 'file' scheme source. Due to
this attackers are able to add an arbitrary directory with system commands
(e.g. ;reboot;) in their apps and put it to cp, resulting in OS command
injection attack with root privileges.
Comment 3 Kurt Seifried 2014-05-19 09:42:29 EDT
Acknowledgements:

This issue was discovered by Jeremy Choi of the Red Hat HSS Pen-test Team.
Comment 4 errata-xmlrpc 2014-05-21 11:45:47 EDT
This issue has been addressed in following products:

  RHEL 6 Version of OpenShift Enterprise 2.0

Via RHSA-2014:0529 https://rhn.redhat.com/errata/RHSA-2014-0529.html
Comment 5 errata-xmlrpc 2014-05-21 11:56:02 EDT
This issue has been addressed in following products:

  RHEL 6 Version of OpenShift Enterprise 2.1

Via RHSA-2014:0530 https://rhn.redhat.com/errata/RHSA-2014-0530.html

Note You need to log in before you can comment on or make changes to this bug.